"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var JsBarcode = require("jsbarcode");
var R = require("ramda");
var base_1 = require("../base");
var util_1 = require("../../util");
var Barcode = /** @class */ (function (_super) {
    __extends(Barcode, _super);
    function Barcode() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.tagId = util_1.uuid(true);
        return _this;
    }
    /**
     * @stable [11.06.2018]
     * @param {Readonly<IBarcodeProps>} prevProps
     * @param {Readonly<{}>} prevState
     */
    Barcode.prototype.componentDidUpdate = function (prevProps, prevState) {
        _super.prototype.componentDidUpdate.call(this, prevProps, prevState);
        if (!R.equals(this.props.barcode, prevProps.barcode)) {
            this.refresh();
        }
    };
    /**
     * @stable [11.06.2018]
     */
    Barcode.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this.refresh();
    };
    /**
     * @stable [11.06.2018]
     * @returns {JSX.Element}
     */
    Barcode.prototype.render = function () {
        return (React.createElement("svg", { id: this.tagId }));
    };
    /**
     * @stable [11.06.2018]
     */
    Barcode.prototype.refresh = function () {
        var props = this.props;
        var options = __assign({}, util_1.defValuesFilter({
            height: props.height,
            fontSize: props.fontSize,
        }));
        JsBarcode("#" + this.tagId)
            .EAN13(props.barcode, options)
            .render();
    };
    return Barcode;
}(base_1.BaseComponent));
exports.Barcode = Barcode;
//# sourceMappingURL=barcode.component.js.map