"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var PropTypes = require("prop-types");
var R = require("ramda");
var DatePickerDialog_1 = require("material-ui/DatePicker/DatePickerDialog");
var util_1 = require("../../../util");
var textfield_1 = require("../textfield");
var DateField = /** @class */ (function (_super) {
    __extends(DateField, _super);
    function DateField(props) {
        var _this = _super.call(this, props) || this;
        _this.onAccept = _this.onAccept.bind(_this);
        _this.defaultActions = R.insert(0, {
            type: 'date_range',
            onClick: function () {
                _this.setFocus();
                _this.dialogWindow.show();
            },
        }, _this.defaultActions);
        return _this;
    }
    DateField.prototype.onKeyEnter = function (event) {
        _super.prototype.onKeyEnter.call(this, event);
        if (this.dialogWindow.state.open) {
            util_1.cancelEvent(event);
        }
    };
    DateField.prototype.getRawValueFromEvent = function (event) {
        return this.tryConvertToDate(_super.prototype.getRawValueFromEvent.call(this, event));
    };
    DateField.prototype.toSerializedValue = function (rawValue) {
        var _this = this;
        // Date value must be able to be serialized as a string
        return util_1.orUndef(!util_1.isUndef(rawValue), function () { return _this.formatDate(rawValue); });
    };
    DateField.prototype.getInputAttachmentElement = function () {
        var props = this.props;
        return (React.createElement(DatePickerDialog_1.default, { ref: 'dialogWindow', autoOk: props.autoOk, cancelLabel: props.cancelLabel, container: props.container, containerStyle: props.dialogContainerStyle, disableYearSelection: props.disableYearSelection, firstDayOfWeek: props.firstDayOfWeek, initialDate: this.dialogDate, locale: props.locale, maxDate: props.maxDate, minDate: props.minDate, mode: props.mode, okLabel: props.okLabel, onAccept: this.onAccept, shouldDisableDate: props.shouldDisableDate, hideCalendarDate: props.hideCalendarDate, openToYearSelection: props.openToYearSelection, utils: props.utils }));
    };
    DateField.prototype.getFieldMask = function () {
        return _super.prototype.getFieldMask.call(this) || this.dateTimeSettings.uiDateMask;
    };
    DateField.prototype.getFieldPattern = function () {
        return _super.prototype.getFieldPattern.call(this) || this.dateTimeSettings.uiDatePattern;
    };
    DateField.prototype.toDisplayValue = function (value) {
        return this.formatDate(_super.prototype.toDisplayValue.call(this, value));
    };
    DateField.prototype.onClick = function (event) {
        _super.prototype.onClick.call(this, event);
        this.dialogWindow.show();
    };
    /**
     * @stable [20.08.2018]
     * @param {Date} date
     */
    DateField.prototype.onAccept = function (date) {
        this.onChangeManually(date);
        this.setFocus(); // UX
    };
    Object.defineProperty(DateField.prototype, "dialogDate", {
        get: function () {
            var value = this.value;
            var defaultDate = this.dc.getCurrentDate();
            if (R.isNil(value)) {
                return defaultDate;
            }
            var dateValue = this.tryConvertToDate(value);
            return dateValue instanceof Date
                ? dateValue
                : defaultDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateField.prototype, "dialogWindow", {
        get: function () {
            return this.refs.dialogWindow;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateField.prototype, "fieldFormat", {
        get: function () {
            return this.props.format || this.dateTimeSettings.uiDateFormat;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DateField.prototype, "dateTimeSettings", {
        get: function () {
            return this.settings.dateTime || {};
        },
        enumerable: true,
        configurable: true
    });
    DateField.prototype.formatDate = function (value) {
        return this.dc.format(value, this.fieldFormat, this.fieldFormat);
    };
    DateField.prototype.tryConvertToDate = function (value) {
        return this.dc.tryConvertToDate(value, this.fieldFormat);
    };
    DateField.defaultProps = {
        container: 'dialog',
        autoOk: true,
        disableYearSelection: false,
        firstDayOfWeek: 1,
        hideCalendarDate: false,
        style: {},
        openToYearSelection: false,
    };
    DateField.contextTypes = {
        muiTheme: PropTypes.object.isRequired,
    };
    return DateField;
}(textfield_1.BasicTextField));
exports.DateField = DateField;
//# sourceMappingURL=datefield.component.js.map