"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../multifield/vue-index");
var vue_base_filefield_component_1 = require("./vue-base-filefield.component");
var VueFileField = /** @class */ (function (_super) {
    __extends(VueFileField, _super);
    function VueFileField() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [25.11.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueFileField.prototype.render = function (createElement) {
        return _super.prototype.render.call(this, createElement);
    };
    /**
     * @stable [28.11.2018]
     * @param newValue
     * @param {AnyT} context
     */
    VueFileField.prototype.onChangeManually = function (newValue, context) {
        _super.prototype.onChangeManually.call(this, newValue, context);
    };
    /**
     * @stable [20.11.2018]
     * @returns {IEntity[]}
     */
    VueFileField.prototype.getFiles = function () {
        if (!this.hasValue()) {
            return util_1.generateArray(1);
        }
        var value = this.getValue();
        if (util_1.isPrimitive(value)) {
            return [value];
        }
        var actualEntities = vue_index_2.toActualMultiItemEntities(value);
        return R.isNil(actualEntities) || actualEntities.length === 0 ? util_1.generateArray(1) : actualEntities;
    };
    // TODO refactoring
    VueFileField.prototype.getViewerComponent = function () {
        var files = this.getFiles();
        return files.length > 0
            ? (files[0].type === 'application/pdf' || (!files[0].newEntity && this.getFileFormat() === 'pdf')
                ? 'vue-pdf-file-viewer' : this.viewer)
            : this.viewer;
    };
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 1; } }),
        __metadata("design:type", Number)
    ], VueFileField.prototype, "maxFiles", void 0);
    VueFileField = __decorate([
        vue_index_1.ComponentName('vue-file-field'),
        vue_property_decorator_1.Component
    ], VueFileField);
    return VueFileField;
}(vue_base_filefield_component_1.VueBaseFileField));
//# sourceMappingURL=vue-filefield.component.js.map