"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../util");
var filter_interface_1 = require("./filter.interface");
var filter_action_builder_1 = require("./filter-action.builder");
function filterReducer(state, action) {
    if (state === void 0) { state = filter_interface_1.INITIAL_APPLICATION_FILTER_STATE; }
    var section = util_1.toSection(action);
    switch (action.type) {
        case filter_action_builder_1.FilterActionBuilder.buildActivateActionType(section):
            return __assign({}, state, { active: true });
        case section + "." + filter_interface_1.FILTER_CHANGE_ACTION_TYPE:
            var data = action.data;
            return __assign({}, state, { query: data.query });
        case section + "." + filter_interface_1.FILTER_DESTROY_ACTION_TYPE:
            return __assign({}, filter_interface_1.INITIAL_APPLICATION_FILTER_STATE);
    }
    return state;
}
exports.filterReducer = filterReducer;
//# sourceMappingURL=filter.reducer.js.map