"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util_1 = require("../../util");
var tabpanel_action_builder_1 = require("./tabpanel-action.builder");
/**
 * @stable [30.08.2018]
 * @param {ITabPanelEntity} state
 * @param {IEffectsAction} action
 * @returns {ITabPanelEntity}
 */
function tabPanelReducer(state, action) {
    if (state === void 0) { state = {}; }
    var section = util_1.toSection(action);
    switch (action.type) {
        case tabpanel_action_builder_1.TabPanelActionBuilder.buildDestroyActionType(section):
            return {};
        case tabpanel_action_builder_1.TabPanelActionBuilder.buildActivateActionType(section):
            var payloadWrapper = action.data;
            return __assign({}, state, { activeValue: payloadWrapper.payload });
    }
    return state;
}
exports.tabPanelReducer = tabPanelReducer;
//# sourceMappingURL=tabpanel.reducer.js.map