"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../util");
var vue_index_1 = require("../connector/vue-index");
var vue_index_2 = require("../base/vue-index");
var VueToggleButton = /** @class */ (function (_super) {
    __extends(VueToggleButton, _super);
    function VueToggleButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [25.10.2018]
     * @param {ILabeledValueEntity} item
     * @returns {string}
     */
    VueToggleButton.prototype.getItemClassName = function (item) {
        return util_1.toClassName('vue-toggle-button-item', 'rac-no-user-select', this.active === item.value && 'vue-toggle-button-item-active');
    };
    /**
     * @stable [25.10.2018]
     * @param {ILabeledValueEntity} item
     */
    VueToggleButton.prototype.onItemClick = function (item) {
        this.$emit('select', item.value);
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Array)
    ], VueToggleButton.prototype, "items", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Number)
    ], VueToggleButton.prototype, "active", void 0);
    VueToggleButton = __decorate([
        vue_index_1.ComponentName('vue-toggle-button'),
        vue_property_decorator_1.Component({
            template: "\n    <vue-flex-layout :className=\"'vue-toggle-button'\"\n                     :row=\"true\"\n                     :full=\"false\">\n      <vue-flex-layout v-for=\"item in items\"\n                       :key=\"item.value\"\n                       :class=\"getItemClassName(item)\"\n                       :row=\"true\"\n                       :full=\"false\"\n                       :alignItemsCenter=\"true\"\n                       :justifyContentCenter=\"true\"\n                       v-on:click.native=\"onItemClick(item)\">\n        {{item.label}}\n      </vue-flex-layout>\n    </vue-flex-layout>\n  ",
        })
    ], VueToggleButton);
    return VueToggleButton;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-toggle-button.component.js.map