/// <reference types="react" />
import { IFieldActionConfiguration } from '../../../configurations-definitions.interface';
import { IUniversalComponent } from '../../../entities-definitions.interface';
import { IUniversalFieldProps } from '../../../props-definitions.interface';
import { IUniversalSearchToolbarProps } from './search-toolbar.interface';
import { UniversalComponent } from '../../base/universal.component';
export declare abstract class UniversalSearchToolbar<TComponent extends IUniversalComponent<TProps, TState>, TProps extends IUniversalSearchToolbarProps, TState = {}> extends UniversalComponent<TComponent, TProps> {
    /**
     * @stable [18.05.2018]
     */
    static readonly defaultProps: IUniversalSearchToolbarProps;
    /**
     * @stable [18.05.2018]
     */
    protected readonly commonActionsProps: Record<number, IFieldActionConfiguration>;
    /**
     * @stable [18.05.2018]
     * @param {TProps} props
     */
    constructor(props: TProps);
    /**
     * @stable [18.05.2018]
     * @returns {boolean}
     */
    protected readonly isActive: boolean;
    /**
     * @stable [18.05.2018]
     * @returns {string}
     */
    protected readonly query: string;
    /**
     * @stable [18.05.2018]
     */
    protected onActivate(): void;
    /**
     * @stable [18.05.2018]
     */
    protected onDeactivate(): void;
    /**
     * @stable [18.05.2018]
     * @param {string} query
     */
    protected onChange(query?: string): void;
    /**
     * @stable [18.05.2018]
     * @returns {IUniversalFieldProps}
     */
    protected readonly fieldProps: IUniversalFieldProps;
    protected readonly actions: IFieldActionConfiguration[];
    /**
     * @stable [18.05.2018]
     * @returns {JSX.Element[]}
     */
    protected readonly actionsElements: JSX.Element[];
    /**
     * @stable [18.05.2018]
     * @returns {JSX.Element}
     */
    protected readonly fieldSection: JSX.Element;
    /**
     * @stable [18.05.2018]
     * @returns {JSX.Element}
     */
    protected readonly actionsElementsSection: JSX.Element[];
    protected abstract getActionElement(config: any): JSX.Element;
    /**
     * @stable [18.05.2018]
     * @returns {JSX.Element}
     */
    protected abstract readonly fieldWrapper: JSX.Element;
    /**
     * @stable [18.05.2018]
     * @returns {JSX.Element}
     */
    protected abstract readonly actionsElementsWrapper: JSX.Element[];
    /**
     * @stable [18.05.2018]
     * @returns {IUniversalField}
     */
    private readonly queryField;
    /**
     * @stable [18.05.2018]
     */
    private onOpen;
    /**
     * @stable [18.05.2018]
     */
    private onApply;
    /**
     * @stable [12.09.2018]
     * @param {ToolbarActionEnum} type
     */
    private onActionClick;
}
