"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var di_1 = require("../../di");
var notification_1 = require("../../notification");
var action_builder_1 = require("../../component/action.builder");
exports.makeFailedEffectsProxy = function (actionType, actionsResolver) {
    return function () {
        var Effects = /** @class */ (function () {
            function Effects() {
            }
            Effects_1 = Effects;
            Effects.prototype.$onError = function (action) {
                return (actionsResolver ? actionsResolver(action) : []).concat(notification_1.NotificationActionBuilder.buildErrorAction(action.error));
            };
            var Effects_1;
            __decorate([
                redux_effects_promise_1.EffectsService.effects(actionType),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Array)
            ], Effects.prototype, "$onError", null);
            Effects = Effects_1 = __decorate([
                di_1.provideInSingleton(Effects_1)
            ], Effects);
            return Effects;
        }());
    };
};
function makeFailedFormEffectsProxy(actionType) {
    return exports.makeFailedEffectsProxy(action_builder_1.FormActionBuilder.buildSubmitErrorActionType(actionType));
}
exports.makeFailedFormEffectsProxy = makeFailedFormEffectsProxy;
function makeFailedListLoadEffectsProxy(section) {
    return exports.makeFailedEffectsProxy(action_builder_1.ListActionBuilder.buildLoadErrorActionType(section));
}
exports.makeFailedListLoadEffectsProxy = makeFailedListLoadEffectsProxy;
function makeFailedListLazyLoadEffectsProxy(section) {
    return exports.makeFailedEffectsProxy(action_builder_1.ListActionBuilder.buildLazyLoadErrorActionType(section));
}
exports.makeFailedListLazyLoadEffectsProxy = makeFailedListLazyLoadEffectsProxy;
function makeFailedFormErrorEffectsProxy(actionType) {
    return exports.makeFailedEffectsProxy(redux_effects_promise_1.EffectsActionBuilder.buildErrorActionType(actionType), function (action) { return [action_builder_1.FormActionBuilder.buildSubmitFinishedAction(action.initialData.section)]; });
}
exports.makeFailedFormErrorEffectsProxy = makeFailedFormErrorEffectsProxy;
//# sourceMappingURL=failed-effects.proxy.js.map