"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var action_builder_1 = require("../../component/action.builder");
var stack_1 = require("../stack");
var router_1 = require("../../router");
/**
 * @stable [26.08.2018]
 */
exports.makeFormFilterSubmitMiddleware = function (config) {
    return [
        stack_1.StackActionBuilder.buildLockAction(config.listSection),
        action_builder_1.FormActionBuilder.buildSubmitFinishedAction(config.filterSection),
        router_1.RouterActionBuilder.buildNavigateBackAction(),
        action_builder_1.ListActionBuilder.buildLoadAction(config.listSection)
    ];
};
/**
 * @stable [26.08.2018]
 */
exports.makeFormFilterResetMiddleware = function (config) {
    return [
        router_1.RouterActionBuilder.buildNavigateBackAction(),
        action_builder_1.ListActionBuilder.buildLoadAction(config.listSection)
    ];
};
/**
 * @stable [26.08.2018]
 */
exports.makeFormFilterClearMiddleware = function (config) {
    return action_builder_1.ListActionBuilder.buildLoadAction(config.listSection);
};
//# sourceMappingURL=form-filter.middleware.js.map