"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var application_action_builder_1 = require("../component/application/application-action.builder");
var di_1 = require("../di");
var TransportErrorInterceptor = /** @class */ (function () {
    function TransportErrorInterceptor() {
    }
    TransportErrorInterceptor.prototype.intercept = function (payload) {
        var error = payload.error;
        if (error.response) {
            switch (error.response.status) {
                case 500:
                    return application_action_builder_1.ApplicationActionBuilder.buildCustomErrorAction(this.settings.messages.serviceTemporarilyUnavailableMessage);
            }
        }
        return null;
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Settings),
        __metadata("design:type", Object)
    ], TransportErrorInterceptor.prototype, "settings", void 0);
    TransportErrorInterceptor = __decorate([
        inversify_1.injectable()
    ], TransportErrorInterceptor);
    return TransportErrorInterceptor;
}());
exports.TransportErrorInterceptor = TransportErrorInterceptor;
//# sourceMappingURL=transport-error.interceptor.js.map